uniform sampler2D tex;

uniform float glowIdx;
uniform float tintr;
uniform float tintg;
uniform float tintb;

uniform float glowr;
uniform float glowg;
uniform float glowb;

uniform bool doTint;
uniform bool doGlow;
uniform bool doFixedGlow;

void glow(vec4);
void fixedglow(vec4);
void tint(vec4);

void glow(vec4 color) {
	
  if(color[0]==0 && color[1]==0 && color[2]==0) {
   gl_FragColor = vec4(glowr*glowIdx/2040, glowg*glowIdx/2040, glowb*glowIdx/2040, color[3]);
  }
  else {
   gl_FragColor = color;
  }
}

void fixedglow(vec4 color) {
  
  if(color[0]==0 && color[1]==0 && color[2]==0) {
   gl_FragColor = vec4(glowr*3/2040, glowg*3/2040, glowb*3/2040, color[3]);
  }
  else {
   gl_FragColor = color;
  }
}

void tint(vec4 color) {

  if(color[0]==color[1] && color[0]==color[2]) {
   gl_FragColor = vec4(color[0]*tintr, color[1]*tintg, color[2]*tintb, color[3]);
  }
  else {
   gl_FragColor = color;
  }
}

void main() {
 
  vec4 color = texture2D(tex,gl_TexCoord[0].st);
  if(doTint) {
    tint(color);
    color=gl_FragColor;
  }
  if(doGlow) glow(color);
  else if(doFixedGlow) fixedglow(color);  
  gl_FragColor*=gl_Color;
}
